Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/IOM/restart.F90	(revision 4292)
@@ -23,5 +23,4 @@
    USE eosbn2          ! equation of state            (eos bn2 routine)
    USE trdmld_oce      ! ocean active mixed layer tracers trends variables
-   USE domvvl          ! variable volume
    USE divcur          ! hor. divergence and curl      (div & cur routines)
    USE sbc_ice, ONLY : lk_lim3
@@ -30,7 +29,8 @@
    PRIVATE
 
-   PUBLIC   rst_opn    ! routine called by step module
-   PUBLIC   rst_write  ! routine called by step module
-   PUBLIC   rst_read   ! routine called by opa  module
+   PUBLIC   rst_opn         ! routine called by step module
+   PUBLIC   rst_write       ! routine called by step module
+   PUBLIC   rst_read        ! routine called by istate module
+   PUBLIC   rst_read_open   ! routine called in rst_read and (possibly) in dom_vvl_init
 
    !! * Substitutions
@@ -120,5 +120,4 @@
                      CALL iom_rstput( kt, nitrst, numrow, 'hdivb'  , hdivb     )
                      CALL iom_rstput( kt, nitrst, numrow, 'sshb'   , sshb      )
-      IF( lk_vvl )   CALL iom_rstput( kt, nitrst, numrow, 'fse3t_b', fse3t_b(:,:,:) )
                      !
                      CALL iom_rstput( kt, nitrst, numrow, 'un'     , un        )     ! now fields
@@ -144,4 +143,37 @@
    END SUBROUTINE rst_write
 
+   SUBROUTINE rst_read_open
+      !!---------------------------------------------------------------------- 
+      !!                   ***  ROUTINE rst_read_open  ***
+      !! 
+      !! ** Purpose :   Open read files for restart (format fixed by jprstlib )
+      !! 
+      !! ** Method  :   Use a non-zero, positive value of numror to assess whether or not
+      !!                the file has already been opened
+      !!----------------------------------------------------------------------
+      INTEGER  ::   jlibalt = jprstlib
+      LOGICAL  ::   llok
+      !!----------------------------------------------------------------------
+
+      IF( numror .LE. 0 ) THEN
+         IF(lwp) THEN                                             ! Contol prints
+            WRITE(numout,*)
+            SELECT CASE ( jprstlib )
+            CASE ( jpnf90    )   ;   WRITE(numout,*) 'rst_read : read oce NetCDF restart file'
+            CASE ( jprstdimg )   ;   WRITE(numout,*) 'rst_read : read oce binary restart file'
+            END SELECT
+            IF ( snc4set%luse )      WRITE(numout,*) 'rst_read : configured with NetCDF4 support'
+            WRITE(numout,*) '~~~~~~~~'
+         ENDIF
+
+         IF ( jprstlib == jprstdimg ) THEN
+           ! eventually read netcdf file (monobloc)  for restarting on different number of processors
+           ! if {cn_ocerst_in}.nc exists, then set jlibalt to jpnf90
+           INQUIRE( FILE = TRIM(cn_ocerst_in)//'.nc', EXIST = llok )
+           IF ( llok ) THEN ; jlibalt = jpnf90  ; ELSE ; jlibalt = jprstlib ; ENDIF
+         ENDIF
+         CALL iom_open( cn_ocerst_in, numror, kiolib = jlibalt )
+      ENDIF
+   END SUBROUTINE rst_read_open
 
    SUBROUTINE rst_read
@@ -154,25 +186,9 @@
       !!----------------------------------------------------------------------
       REAL(wp) ::   zrdt, zrdttra1
-      INTEGER  ::   jk, jlibalt = jprstlib
+      INTEGER  ::   jk
       LOGICAL  ::   llok
       !!----------------------------------------------------------------------
 
-      IF(lwp) THEN                                             ! Contol prints
-         WRITE(numout,*)
-         SELECT CASE ( jprstlib )
-         CASE ( jpnf90    )   ;   WRITE(numout,*) 'rst_read : read oce NetCDF restart file ',TRIM(cn_ocerst_in)//'.nc'
-         CASE ( jprstdimg )   ;   WRITE(numout,*) 'rst_read : read oce binary restart file'
-         END SELECT
-         IF ( snc4set%luse )      WRITE(numout,*) 'rst_read : configured with NetCDF4 support'
-         WRITE(numout,*) '~~~~~~~~'
-      ENDIF
-
-      IF ( jprstlib == jprstdimg ) THEN
-        ! eventually read netcdf file (monobloc)  for restarting on different number of processors
-        ! if {cn_ocerst_in}.nc exists, then set jlibalt to jpnf90
-        INQUIRE( FILE = TRIM(cn_ocerst_in)//'.nc', EXIST = llok )
-        IF ( llok ) THEN ; jlibalt = jpnf90  ; ELSE ; jlibalt = jprstlib ; ENDIF
-      ENDIF
-      CALL iom_open( cn_ocerst_in, numror, kiolib = jlibalt )
+      CALL rst_read_open           ! open restart for reading (if not already opened)
 
       ! Check dynamics and tracer time-step consistency and force Euler restart if changed
@@ -194,5 +210,4 @@
          CALL iom_get( numror, jpdom_autoglo, 'hdivb'  , hdivb   )
          CALL iom_get( numror, jpdom_autoglo, 'sshb'   , sshb    )
-         IF( lk_vvl )   CALL iom_get( numror, jpdom_autoglo, 'fse3t_b', fse3t_b(:,:,:) )
       ELSE
          neuler = 0
@@ -230,9 +245,4 @@
          hdivb(:,:,:)   = hdivn(:,:,:)
          sshb (:,:)     = sshn (:,:)
-         IF( lk_vvl ) THEN
-            DO jk = 1, jpk
-               fse3t_b(:,:,jk) = fse3t_n(:,:,jk)
-            END DO
-         ENDIF
       ENDIF
       !
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn.F90	(revision 4292)
@@ -191,6 +191,6 @@
       !!----------------------------------------------------------------------
 
-      zm00 = TANH( ( pdam - gdept_0(1    ) ) / pwam )
-      zm01 = TANH( ( pdam - gdept_0(jpkm1) ) / pwam )
+      zm00 = TANH( ( pdam - gdept_1d(1    ) ) / pwam )
+      zm01 = TANH( ( pdam - gdept_1d(jpkm1) ) / pwam )
       zmhs = zm00 / zm01
       zmhb = ( 1.e0 - pbot ) / ( 1.e0 - zmhs ) / zm01
@@ -232,6 +232,6 @@
       !!----------------------------------------------------------------------
 
-      zm00 = TANH( ( pdam - gdept_0(1    ) ) / pwam )
-      zm01 = TANH( ( pdam - gdept_0(jpkm1) ) / pwam )
+      zm00 = TANH( ( pdam - gdept_1d(1    ) ) / pwam )
+      zm01 = TANH( ( pdam - gdept_1d(jpkm1) ) / pwam )
       zmhs = zm00 / zm01
       zmhb = ( 1.e0 - pbot ) / ( 1.e0 - zmhs ) / zm01
@@ -274,6 +274,6 @@
       !!----------------------------------------------------------------------
 
-      zm00 = TANH( ( pdam - gdept_0(1    ) ) / pwam )   
-      zm01 = TANH( ( pdam - gdept_0(jpkm1) ) / pwam )
+      zm00 = TANH( ( pdam - gdept_1d(1    ) ) / pwam )   
+      zm01 = TANH( ( pdam - gdept_1d(jpkm1) ) / pwam )
       zmhs = zm00 / zm01
       zmhb = ( 1.e0 - pbot ) / ( 1.e0 - zmhs ) / zm01
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/LDF/ldfdyn_c3d.h90	(revision 4292)
@@ -386,5 +386,5 @@
 
       DO jk=1, jpk
-         zcoef(jk) = 1.0_wp + NINT(9.0_wp*(gdept_0(jk)-800.0_wp)/(3000.0_wp-800.0_wp))
+         zcoef(jk) = 1.0_wp + NINT(9.0_wp*(gdept_1d(jk)-800.0_wp)/(3000.0_wp-800.0_wp))
          zcoef(jk) = MIN(10.0_wp, MAX(1.0_wp, zcoef(jk)))
          IF(lwp) WRITE(numout,'(4x,i3,6x,f7.3)') jk,zcoef(jk)
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/diaobs.F90	(revision 4292)
@@ -976,5 +976,5 @@
       USE dom_oce, ONLY : &             ! Ocean space and time domain variables
          & rdt,           &                       
-         & gdept_0,       &             
+         & gdept_1d,       &             
          & tmask, umask, vmask                            
       USE phycst, ONLY : &              ! Physical constants
@@ -1038,5 +1038,5 @@
                   &              kstp, jpi, jpj, jpk, nit000, idaystp,   &
                   &              tsn(:,:,:,jp_tem), tsn(:,:,:,jp_sal),   &
-                  &              gdept_0, tmask, n1dint, n2dint,         &
+                  &              gdept_1d, tmask, n1dint, n2dint,        &
                   &              kdailyavtypes = endailyavtypes )
             ELSE
@@ -1044,5 +1044,5 @@
                   &              kstp, jpi, jpj, jpk, nit000, idaystp,   &
                   &              tsn(:,:,:,jp_tem), tsn(:,:,:,jp_sal),   &
-                  &              gdept_0, tmask, n1dint, n2dint               )
+                  &              gdept_1d, tmask, n1dint, n2dint              )
             ENDIF
          END DO
@@ -1088,5 +1088,5 @@
            ! zonal component of velocity
            CALL obs_vel_opt( veldatqc(jveloset), kstp, jpi, jpj, jpk, &
-              &              nit000, idaystp, un, vn, gdept_0, umask, vmask, &
+              &              nit000, idaystp, un, vn, gdept_1d, umask, vmask, &
                              n1dint, n2dint, ld_velav(jveloset) )
          END DO
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_prep.F90	(revision 4292)
@@ -75,5 +75,5 @@
          & glamt,   &
          & gphit,   &
-         & gdept_0, &
+         & gdept_1d,&
          & tmask,   &
          & nproc
@@ -193,5 +193,5 @@
          &                 profdata%var(1)%vdep,                        &
          &                 glamt,                 gphit,                &
-         &                 gdept_0,               tmask,                &
+         &                 gdept_1d,              tmask,                &
          &                 profdata%nqc,          profdata%var(1)%nvqc, &
          &                 iosdtobs,              ilantobs,             &
@@ -213,5 +213,5 @@
          &                 profdata%var(2)%vdep,                        &
          &                 glamt,                 gphit,                &
-         &                 gdept_0,               tmask,                &
+         &                 gdept_1d,              tmask,                &
          &                 profdata%nqc,          profdata%var(2)%nvqc, &
          &                 iosdsobs,              ilansobs,             &
@@ -916,5 +916,5 @@
          & glamt, glamu, glamv,    &
          & gphit, gphiu, gphiv,    &
-         & gdept_0, &
+         & gdept_1d,             &
          & tmask, umask, vmask,  &
          & nproc
@@ -1032,5 +1032,5 @@
          &                 profdata%var(1)%vdep,                        &
          &                 glamu,                 gphiu,                &
-         &                 gdept_0,               umask,                &
+         &                 gdept_1d,              umask,                &
          &                 profdata%nqc,          profdata%var(1)%nvqc, &
          &                 iosduobs,              ilanuobs,             &
@@ -1052,5 +1052,5 @@
          &                 profdata%var(2)%vdep,                        &
          &                 glamv,                 gphiv,                &
-         &                 gdept_0,               vmask,                &
+         &                 gdept_1d,              vmask,                &
          &                 profdata%nqc,          profdata%var(2)%nvqc, &
          &                 iosdvobs,              ilanvobs,             &
@@ -1709,5 +1709,5 @@
       !! * Modules used
       USE dom_oce, ONLY : &       ! Geographical information
-         & gdepw_0                        
+         & gdepw_1d                        
 
       !! * Arguments
@@ -1826,5 +1826,5 @@
                &  .OR. ( pobsphi(jobs) >   90.         )       &
                &  .OR. ( pobsdep(jobsp) < 0.0          )       &
-               &  .OR. ( pobsdep(jobsp) > gdepw_0(kpk) ) ) THEN
+               &  .OR. ( pobsdep(jobsp) > gdepw_1d(kpk)) ) THEN
                kobsqc(jobsp) = kobsqc(jobsp) + 11
                kosdobs = kosdobs + 1
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_prof.F90	(revision 4292)
@@ -793,10 +793,10 @@
       !-----------------------------------------------------------------------
       IF ( ldt3d ) THEN
-         CALL obs_level_search( jpk, gdept_0, &
+         CALL obs_level_search( jpk, gdept_1d, &
             & profdata%nvprot(1), profdata%var(1)%vdep, &
             & profdata%var(1)%mvk )
       ENDIF
       IF ( lds3d ) THEN
-         CALL obs_level_search( jpk, gdept_0, &
+         CALL obs_level_search( jpk, gdept_1d, &
             & profdata%nvprot(2), profdata%var(2)%vdep, &
             & profdata%var(2)%mvk )
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_vel.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_vel.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/OBS/obs_read_vel.F90	(revision 4292)
@@ -614,8 +614,8 @@
       ! Model level search
       !-----------------------------------------------------------------------
-      CALL obs_level_search( jpk, gdept_0, &
+      CALL obs_level_search( jpk, gdept_1d,          &
          & profdata%nvprot(1), profdata%var(1)%vdep, &
          & profdata%var(1)%mvk )
-      CALL obs_level_search( jpk, gdept_0, &
+      CALL obs_level_search( jpk, gdept_1d,          &
          & profdata%nvprot(2), profdata%var(2)%vdep, &
          & profdata%var(2)%mvk )
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbc_oce.F90	(revision 4292)
@@ -100,4 +100,5 @@
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   sss_m     !: mean (nn_fsbc time-step) surface sea salinity            [psu]
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   ssh_m     !: mean (nn_fsbc time-step) sea surface height                [m]
+   REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:) ::   e3t_m     !: mean (nn_fsbc time-step) sea surface height                [m]
 
    !! * Substitutions
@@ -114,5 +115,5 @@
       !!                  ***  FUNCTION sbc_oce_alloc  ***
       !!---------------------------------------------------------------------
-      INTEGER :: ierr(4)
+      INTEGER :: ierr(5)
       !!---------------------------------------------------------------------
       ierr(:) = 0
@@ -135,4 +136,8 @@
          &      ssu_m  (jpi,jpj) , sst_m(jpi,jpj) ,                       &
          &      ssv_m  (jpi,jpj) , sss_m  (jpi,jpj), ssh_m(jpi,jpj) , STAT=ierr(4) )
+         !
+#if defined key_vvl
+      ALLOCATE( e3t_m(jpi,jpj) , STAT=ierr(5) )
+#endif
          !
       sbc_oce_alloc = MAXVAL( ierr )
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcice_cice.F90	(revision 4292)
@@ -412,5 +412,5 @@
 ! Freezing/melting potential
 ! Calculated over NEMO leapfrog timestep (hence 2*dt)
-      nfrzmlt(:,:)=rau0*rcp*fse3t_m(:,:,1)*(Tocnfrz-sst_m(:,:))/(2.0*dt)
+      nfrzmlt(:,:)=rau0*rcp*fse3t_m(:,:)*(Tocnfrz-sst_m(:,:))/(2.0*dt)
 
       ztmp(:,:) = nfrzmlt(:,:)
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcrnf.F90	(revision 4292)
@@ -388,5 +388,5 @@
          IF( rn_hrnf > 0._wp ) THEN
             nkrnf = 2
-            DO WHILE( nkrnf /= jpkm1 .AND. gdepw_0(nkrnf+1) < rn_hrnf )   ;   nkrnf = nkrnf + 1   ;   END DO
+            DO WHILE( nkrnf /= jpkm1 .AND. gdepw_1d(nkrnf+1) < rn_hrnf )   ;   nkrnf = nkrnf + 1   ;   END DO
             IF( ln_sco )   CALL ctl_warn( 'sbc_rnf: number of levels over which Kz is increased is computed for zco...' )
          ENDIF
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcssm.F90	(revision 4292)
@@ -26,8 +26,8 @@
    PUBLIC   sbc_ssm         ! routine called by step.F90
    PUBLIC   sbc_ssm_init    ! routine called by sbcmod.F90
-   
+
    LOGICAL, SAVE  ::   l_ssm_mean = .FALSE.       ! keep track of whether means have been read
                                                   ! from restart file
-
+   
    !! * Substitutions
 #  include "domzgr_substitute.h90"
@@ -67,5 +67,6 @@
          ELSE                    ;   ssh_m(:,:) = sshn(:,:)
          ENDIF
-
+         !
+         IF( lk_vvl )   fse3t_m(:,:) = fse3t_n(:,:,1)
          !
       ELSE
@@ -84,4 +85,5 @@
             ELSE                    ;   ssh_m(:,:) = zcoef *   sshn(:,:)
             ENDIF
+            IF( lk_vvl )   fse3t_m(:,:) = zcoef * fse3t_n(:,:,1)
             !                                             ! ---------------------------------------- !
          ELSEIF( MOD( kt - 2 , nn_fsbc ) == 0 ) THEN      !   Initialisation: New mean computation   !
@@ -92,4 +94,5 @@
             sss_m(:,:) = 0.e0
             ssh_m(:,:) = 0.e0
+            IF( lk_vvl )   fse3t_m(:,:) = 0.e0
          ENDIF
          !                                                ! ---------------------------------------- !
@@ -104,4 +107,5 @@
          ELSE                    ;   ssh_m(:,:) = ssh_m(:,:) + sshn(:,:)
          ENDIF
+         IF( lk_vvl )   fse3t_m(:,:) = fse3t_m(:,:) + fse3t_n(:,:,1)
 
          !                                                ! ---------------------------------------- !
@@ -114,4 +118,5 @@
             ssv_m(:,:) = ssv_m(:,:) * zcoef           !
             ssh_m(:,:) = ssh_m(:,:) * zcoef           ! mean SSH             [m]
+            IF( lk_vvl )   fse3t_m(:,:) = fse3t_m(:,:) * zcoef   ! mean vertical scale factor [m]
             !
          ENDIF
@@ -130,4 +135,7 @@
             CALL iom_rstput( kt, nitrst, numrow, 'sss_m'  , sss_m  )
             CALL iom_rstput( kt, nitrst, numrow, 'ssh_m'  , ssh_m  )
+            IF( lk_vvl ) THEN
+               CALL iom_rstput( kt, nitrst, numrow, 'fse3t_m'  , fse3t_m(:,:)  )
+            END IF
             !
          ENDIF
@@ -168,4 +176,5 @@
             CALL iom_get( numror, jpdom_autoglo, 'sss_m'  , sss_m  )   !   "         "    salinity    (T-point)
             CALL iom_get( numror, jpdom_autoglo, 'ssh_m'  , ssh_m  )   !   "         "    height      (T-point)
+            IF( lk_vvl ) CALL iom_get( numror, jpdom_autoglo, 'fse3t_m', fse3t_m(:,:) )
             !
             IF( zf_sbc /= REAL( nn_fsbc, wp ) ) THEN      ! nn_fsbc has changed between 2 runs
@@ -178,4 +187,5 @@
                sss_m(:,:) = zcoef * sss_m(:,:)
                ssh_m(:,:) = zcoef * ssh_m(:,:)
+               IF( lk_vvl ) fse3t_m(:,:) = zcoef * fse3t_m(:,:)
             ELSE
                IF(lwp) WRITE(numout,*) '~~~~~~~   mean fields read in the ocean restart file'
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbctide.F90	(revision 4292)
@@ -1,107 +1,116 @@
 MODULE sbctide
-  !!=================================================================================
-  !!                       ***  MODULE  sbctide  ***
-  !! Initialization of tidal forcing
-  !! History :  9.0  !  07  (O. Le Galloudec)  Original code
-  !!=================================================================================
-  !! * Modules used
-  USE oce             ! ocean dynamics and tracers variables
-  USE dom_oce         ! ocean space and time domain
-  USE in_out_manager  ! I/O units
-  USE ioipsl          ! NetCDF IPSL library
-  USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-  USE phycst
-  USE daymod
-  USE dynspg_oce
-  USE tideini
-  USE iom
+   !!======================================================================
+   !!                       ***  MODULE  sbctide  ***
+   !! Initialization of tidal forcing
+   !!======================================================================
+   !! History :  9.0  !  2007  (O. Le Galloudec)  Original code
+   !!----------------------------------------------------------------------
+   USE oce             ! ocean dynamics and tracers variables
+   USE dom_oce         ! ocean space and time domain
+   USE phycst
+   USE daymod
+   USE dynspg_oce
+   USE tideini
+   !
+   USE iom
+   USE in_out_manager  ! I/O units
+   USE ioipsl          ! NetCDF IPSL library
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
 
-  IMPLICIT NONE
-  PUBLIC
+   IMPLICIT NONE
+   PUBLIC
 
-  REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:) :: pot_astro
+   REAL(wp), PUBLIC, ALLOCATABLE, DIMENSION(:,:) ::   pot_astro   !
 
 #if defined key_tide
+   !!----------------------------------------------------------------------
+   !!   'key_tide' :                                        tidal potential
+   !!----------------------------------------------------------------------
+   !!   sbc_tide            : 
+   !!   tide_init_potential :
+   !!----------------------------------------------------------------------
 
-  LOGICAL, PUBLIC, PARAMETER ::   lk_tide  = .TRUE.
-  REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) :: amp_pot,phi_pot
-  !!---------------------------------------------------------------------------------
-  !!   OPA 9.0 , LODYC-IPSL  (2003)
-  !!---------------------------------------------------------------------------------
+   LOGICAL, PUBLIC, PARAMETER ::   lk_tide  = .TRUE.
+   REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   amp_pot, phi_pot
 
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.5 , NEMO Consortium (2013)
+   !! $Id: $
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
-  SUBROUTINE sbc_tide ( kt )
-    !!----------------------------------------------------------------------
-    !!                 ***  ROUTINE sbc_tide  ***
-    !!----------------------------------------------------------------------      
-    !! * Arguments
-    INTEGER, INTENT( in ) ::   kt     ! ocean time-step
-    !!----------------------------------------------------------------------
+   SUBROUTINE sbc_tide( kt )
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE sbc_tide  ***
+      !!----------------------------------------------------------------------      
+      INTEGER, INTENT( in ) ::   kt     ! ocean time-step
+      INTEGER               ::   jk     ! dummy loop index
+      !!----------------------------------------------------------------------
 
-    IF ( kt == nit000 .AND. .NOT. lk_dynspg_ts )  CALL ctl_stop( 'STOP', 'sbc_tide : tidal potential use only with time splitting' )
-
-    IF ( nsec_day == NINT(0.5 * rdttra(1)) ) THEN
+      IF( nsec_day == NINT(0.5_wp * rdttra(1)) ) THEN      ! start a new day
+         !
+         IF( kt == nit000 ) THEN
+            ALLOCATE( amp_pot(jpi,jpj,nb_harmo),                      &
+               &      phi_pot(jpi,jpj,nb_harmo), pot_astro(jpi,jpj)   )
+         ENDIF
+         !
+         amp_pot(:,:,:) = 0._wp
+         phi_pot(:,:,:) = 0._wp
+         pot_astro(:,:) = 0._wp
+         !
+         CALL tide_harmo( omega_tide, v0tide, utide, ftide, ntide, nb_harmo )
+         !
+         kt_tide = kt
+         !
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) 'sbc_tide : Update of the components and (re)Init. the potential at kt=', kt
+            WRITE(numout,*) '~~~~~~~~ '
+            DO jk = 1, nb_harmo
+               WRITE(numout,*) Wave(ntide(jk))%cname_tide, utide(jk), ftide(jk), v0tide(jk), omega_tide(jk)
+            END DO
+         ENDIF
+         !
+         IF( ln_tide_pot )   CALL tide_init_potential
+         !
+      ENDIF
       !
-      kt_tide = kt
-
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'sbc_tide : (re)Initialization of the tidal potential at kt=',kt
-         WRITE(numout,*) '~~~~~~~ '
-      ENDIF
-
-      IF(lwp) THEN
-         IF ( kt == nit000 ) WRITE(numout,*) 'Apply astronomical potential : ln_tide_pot =', ln_tide_pot
-         CALL flush(numout)
-      ENDIF
-
-      IF ( kt == nit000 ) ALLOCATE(amp_pot(jpi,jpj,nb_harmo))
-      IF ( kt == nit000 ) ALLOCATE(phi_pot(jpi,jpj,nb_harmo))
-      IF ( kt == nit000 ) ALLOCATE(pot_astro(jpi,jpj))
-
-      amp_pot(:,:,:) = 0.e0
-      phi_pot(:,:,:) = 0.e0
-      pot_astro(:,:) = 0.e0
-
-      IF ( ln_tide_pot ) CALL tide_init_potential
-      !
-    ENDIF
-
-  END SUBROUTINE sbc_tide
-
-  SUBROUTINE tide_init_potential
-    !!----------------------------------------------------------------------
-    !!                 ***  ROUTINE tide_init_potential  ***
-    !!----------------------------------------------------------------------
-    !! * Local declarations
-    INTEGER  :: ji,jj,jk
-    REAL(wp) :: zcons,ztmp1,ztmp2,zlat,zlon
+   END SUBROUTINE sbc_tide
 
 
-    DO jk=1,nb_harmo
-       zcons=0.7*Wave(ntide(jk))%equitide*ftide(jk)
-       do ji=1,jpi
-          do jj=1,jpj
-             ztmp1 = amp_pot(ji,jj,jk)*COS(phi_pot(ji,jj,jk))
-             ztmp2 = -amp_pot(ji,jj,jk)*SIN(phi_pot(ji,jj,jk))
-             zlat = gphit(ji,jj)*rad !! latitude en radian
-             zlon = glamt(ji,jj)*rad !! longitude en radian
-             ! le potentiel est composé des effets des astres:
-             IF (Wave(ntide(jk))%nutide .EQ.1) THEN
-                ztmp1= ztmp1 + zcons*(SIN(2.*zlat))*COS(v0tide(jk)+utide(jk)+Wave(ntide(jk))%nutide*zlon)
-                ztmp2= ztmp2 - zcons*(SIN(2.*zlat))*SIN(v0tide(jk)+utide(jk)+Wave(ntide(jk))%nutide*zlon)
-             ENDIF
-             IF (Wave(ntide(jk))%nutide.EQ.2) THEN
-                ztmp1= ztmp1 + zcons*(COS(zlat)**2)*COS(v0tide(jk)+utide(jk)+Wave(ntide(jk))%nutide*zlon)
-                ztmp2= ztmp2 - zcons*(COS(zlat)**2)*SIN(v0tide(jk)+utide(jk)+Wave(ntide(jk))%nutide*zlon)
-             ENDIF
-             amp_pot(ji,jj,jk)=SQRT(ztmp1**2+ztmp2**2)
-             phi_pot(ji,jj,jk)=ATAN2(-ztmp2/MAX(1.E-10,SQRT(ztmp1**2+ztmp2**2)),ztmp1/MAX(1.E-10,SQRT(ztmp1**2+ztmp2**2)))
-          enddo
-       enddo
-    END DO
+   SUBROUTINE tide_init_potential
+      !!----------------------------------------------------------------------
+      !!                 ***  ROUTINE tide_init_potential  ***
+      !!----------------------------------------------------------------------
+      INTEGER  ::   ji, jj, jk   ! dummy loop indices
+      REAL(wp) ::   zcons, ztmp1, ztmp2, zlat, zlon, ztmp, zamp, zcs   ! local scalar
+      !!----------------------------------------------------------------------
 
-  END SUBROUTINE tide_init_potential
+      DO jk = 1, nb_harmo
+         zcons = 0.7_wp * Wave(ntide(jk))%equitide * ftide(jk)
+         DO ji = 1, jpi
+            DO jj = 1, jpj
+               ztmp1 =  amp_pot(ji,jj,jk) * COS( phi_pot(ji,jj,jk) )
+               ztmp2 = -amp_pot(ji,jj,jk) * SIN( phi_pot(ji,jj,jk) )
+               zlat = gphit(ji,jj)*rad !! latitude en radian
+               zlon = glamt(ji,jj)*rad !! longitude en radian
+               ztmp = v0tide(jk) + utide(jk) + Wave(ntide(jk))%nutide * zlon
+               ! le potentiel est composé des effets des astres:
+               IF    ( Wave(ntide(jk))%nutide == 1 )  THEN  ;  zcs = zcons * SIN( 2._wp*zlat )
+               ELSEIF( Wave(ntide(jk))%nutide == 2 )  THEN  ;  zcs = zcons * COS( zlat )**2
+               ELSE                                         ;  zcs = 0._wp
+               ENDIF
+               ztmp1 = ztmp1 + zcs * COS( ztmp )
+               ztmp2 = ztmp2 - zcs * SIN( ztmp )
+               zamp = SQRT( ztmp1*ztmp1 + ztmp2*ztmp2 )
+               amp_pot(ji,jj,jk) = zamp
+               phi_pot(ji,jj,jk) = ATAN2( -ztmp2 / MAX( 1.e-10_wp , zamp ) ,   &
+                  &                        ztmp1 / MAX( 1.e-10_wp,  zamp )   )
+            END DO
+         END DO
+      END DO
+      !
+   END SUBROUTINE tide_init_potential
 
 #else
@@ -116,5 +125,5 @@
   END SUBROUTINE sbc_tide
 #endif
+
   !!======================================================================
-
 END MODULE sbctide
Index: /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90
===================================================================
--- /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 4291)
+++ /branches/2013/dev_MERGE_2013/NEMOGCM/NEMO/OPA_SRC/SBC/sbcwave.F90	(revision 4292)
@@ -151,10 +151,10 @@
              DO jj = 1, jpj-1
                 DO ji = 1, jpi-1
-                   usd3d(ji,jj,jk) = usd2d(ji,jj)*exp(2.0*uwavenum(ji,jj)*(-MIN( gdept(ji,jj,jk) , gdept(ji+1,jj  ,jk))))
-                   vsd3d(ji,jj,jk) = vsd2d(ji,jj)*exp(2.0*vwavenum(ji,jj)*(-MIN( gdept(ji,jj,jk) , gdept(ji  ,jj+1,jk))))
+                   usd3d(ji,jj,jk) = usd2d(ji,jj)*exp(2.0*uwavenum(ji,jj)*(-MIN( gdept_0(ji,jj,jk) , gdept_0(ji+1,jj  ,jk))))
+                   vsd3d(ji,jj,jk) = vsd2d(ji,jj)*exp(2.0*vwavenum(ji,jj)*(-MIN( gdept_0(ji,jj,jk) , gdept_0(ji  ,jj+1,jk))))
                 END DO
              END DO
-             usd3d(jpi,:,jk) = usd2d(jpi,:)*exp( 2.0*uwavenum(jpi,:)*(-gdept(jpi,:,jk)) )
-             vsd3d(:,jpj,jk) = vsd2d(:,jpj)*exp( 2.0*vwavenum(:,jpj)*(-gdept(:,jpj,jk)) )
+             usd3d(jpi,:,jk) = usd2d(jpi,:)*exp( 2.0*uwavenum(jpi,:)*(-gdept_0(jpi,:,jk)) )
+             vsd3d(:,jpj,jk) = vsd2d(:,jpj)*exp( 2.0*vwavenum(:,jpj)*(-gdept_0(:,jpj,jk)) )
           END DO
 
